import { Token } from "./token";
import type { IContainer } from "../interfaces";
import type { Constructable } from "../types";
export declare class Container implements IContainer {
    private readonly registeredDependencies;
    private readonly resolvedSingletonDependencies;
    private readonly selfCreatedDependencyTokens;
    resolve<T>(dependency: Token<T>): T;
    resolve<T, TArgs extends Array<unknown>>(dependency: Constructable<T, TArgs>): T;
    registerSingleton<T, TArgs extends Array<unknown>>(token: Constructable<T, TArgs>): void;
    registerSingleton<T, TArgs extends Array<unknown>>(token: Token<T>, dependency: Constructable<T, TArgs>): void;
    registerTransient<T, TArgs extends Array<unknown>>(token: Constructable<T, TArgs>): void;
    registerTransient<T, TArgs extends Array<unknown>>(token: Token<T>, dependency: Constructable<T, TArgs>): void;
    private registerDependencyOnce;
    private resolveDependency;
    private resolveSingletonDependency;
    private resolveDependencyChain;
    private verifyDependencyPresenceInContainer;
    private resolveDependencyCustomMetadata;
    private resolveDependencyParamTypesMetadata;
    private createDependencyToken;
}
